#ifndef _CL_STRUC_CH_

#include "oObject.ch"

// Structure of new structure Array
#define ST_NAME            1
#define ST_INSTANCE        2
#define ST_MEMBERS         3

// Structure of members Array
#define MBR_NAME           1
#define MBR_VALUE          2
#define MBR_IS_INLINE      3


#xcommand STRUC <cStruc> {  => m->____oS := Struc():New( #<cStruc> )

#xcommand MEMBER <cMember> [AS <xData>] => ;
          m->____oS:AddMember( #<cMember>, <xData>, .F. )

#xcommand MEMBER <cMember> AS STRUC <cStruc> => ;
          m->____oS:AddMember( #<cMember>, StrucGet( #<cStruc> ), .F. )

#xcommand MEMBER <cMember> INLINE <xData,...> => ;
          m->____oS:AddMember( #<cMember> ,{|self| <xData> }, .T. )

#xcommand MEMBER <cMember>([<parms,...>]) INLINE <xData,...> => ;
          m->____oS:AddMember( #<cMember> , {|self[,<parms>]| <xData> }, .T. )

#xCommand } STRUC TO <oObj> => <oObj> := m->____oS:EndStruc() ;;
                               __MXRelease( m->____oS )

#xCommand STRUC <cStruc> TO <oObj> => <oObj> := StrucGet( #<cStruc> )

#xCommand UNION <struc1>, <struc2> TO <newstruc> OF <oVar> => ;
          <oVar> := StrucUnite( <"struc1">, <"struc2">, <"newstruc"> )

#xCommand UNION { <s1>, <s2> }<newstruc> TO <o> => ;
            <o> := StrucUnite( #<s1>, #<s2>, #<newstruc> )

#define _CL_STRUC_CH_
#endif
