#include "Struc.ch"

REQUEST DBFCDX


//
PROC Test()

LOCAL o, o2
USE Test NEW VIA "DBFCDX"

STRUC Data {                              // name of the structure
       MEMBER d1 AS 0                     // define members
       MEMBER d2 AS 10
       MEMBER d3 AS 20
       MEMBER d4 AS 30000
       MEMBER d5( n ) INLINE ::d1 := n    // member as code
} STRUC TO o                              // assign struc to var

? "Struc o  ->", o:d1, o:d2, o:d3, o:d4
o:d5( 100000000 )
? "Struc o  ->", o:d1

STRUC TestDbf {
       MEMBER nRec     AS 1
       MEMBER Name     AS test->name
       MEMBER Address  AS test->address
       MEMBER City     AS test->city
       MEMBER ooo      AS STRUC Data
       MEMBER Access() INLINE  test->(dbGoTo( if( ::nRec!=NIL, ::nRec, test->(recno()) )) )     ,;
                               ::Name        := test->name    ,;
                               ::Address     := test->address ,;
                               ::City        := test->city

       MEMBER Assign() INLINE  test->(dbGoTo( ::nRec ) ),;
                               test->name    := ::Name   ,;
                               test->address := ::Address,;
                               test->city    := ::City

       MEMBER Skip( n ) INLINE Test->( dbSkip( n ) ),;
                               ::nRec := test->(recno()),;
                               ::Access()

       MEMBER Goto( n ) INLINE Test->( dbGoTo( n ) ),;
                               ::nRec := test->(recno()),;
                               ::Access()

} STRUC TO o

// Create instance of existing structure...

STRUC TestDbf TO o2

?
? "Data from Nested Structure:"
? "--------------------------------------------------------"
? "o:ooo:d1 ->", o:ooo:d1
? "o:ooo:d2 ->", o:ooo:d2
? "--------------------------------------------------------"
?
? "Struc o  ->",o:Name, o:Address
o:skip( 1 )
? "Struc o  ->", o:Name, o:Address
?
o2:GoTo( 5 ) ; o2:Access()
? "Struc o2 ->", o2:nRec, o2:Name, o2:Address
?
o:goto( o:nRec )
? "Struc o  ->", o:nRec, o:Name, o:Address
o:goto( 10 )
o2:goto( 8 )
? "o:nRec   ->",o:nRec, "o2:nRec", o2:nRec
?

//UNION data, testdbf TO NewStruc1 OF o
UNION { data, testdbf } NewStruc2 TO o
? "From union: o:d1, o:d2 & o:Name"
? o:d1
? o:d2
? o:Name
